package jumbo.xml;

import java.util.Vector;

import java.io.OutputStream;
import java.io.PrintStream;
import java.io.PrintWriter;

/** crude device to capture output of stack trace
@author P.Murray-Rust, 1998
*/

public class StackTraceWriter extends PrintWriter {
	Vector stringVector;
	public StackTraceWriter() {
		super(new DummyOutputStream());    // not used
		stringVector = new Vector();
	}

	public void println(String s) {
		stringVector.addElement(s);
	}

// this appears to be the way that stacktraces are built up
	public void println(char[] ch) {
		String s = new String(ch);
		stringVector.addElement(s);
	}

/** the components are built up as a vector of Strings
*/
	public Vector getStringVector() {
		return stringVector;
	}

/** alternatively the Strings can be retrieved as String[]
*/
	public String[] getStackTrace() {
		String[] ss = new String[stringVector.size()];
		for (int i = 0; i < stringVector.size(); i++) {
			ss[i] = (String) stringVector.elementAt(i);
		}
		return ss;
	}

/** alternatively the Strings can be retrieved as String[]
*/
	public String toString() {
		String s = "";
		for (int i = 0; i < stringVector.size(); i++) {
			s += (String) stringVector.elementAt(i)+"\n";
		}
		return s;
	}

	public void printStackTrace() {
		System.out.println(""+toString());
	}

/** deliberately throws an exception
*/
	public static void test() {
		String s = null;
		s.indexOf("a");
	}

	public static void main(String[] args) {
		try {
			test();
		} catch (NullPointerException e) {
// this just ouputs the exception
			System.out.println(e);
			StackTraceWriter stw = new StackTraceWriter();
// this captures the trace without output
			e.printStackTrace(stw);
// this outputs it
			stw.printStackTrace();
			System.out.println("--------------------------");
// this accesses the components
			Vector v = stw.getStringVector();
			for (int i = 0; i < v.size(); i++) {
				System.out.println(v.elementAt(i));
			}
		}
	}
}
class DummyOutputStream extends OutputStream {
	public DummyOutputStream() {
	}
	public void write(int i) {}
}